﻿Imports System.Windows.Forms.AxHost
Imports System.Windows.Forms.VisualStyles.VisualStyleElement.ListView
Imports ErrorLog.LogStates

Public Class ucStatusLine
    Public WithEvents ErrorLog As ucErrorLog
    Private oError As ErrorDetail
    Private bShowDetails As Boolean
    Private sLocation As String

    Public Property ShowDetailsButton
        Get
            Return bShowDetails
        End Get
        Set(value)
            bShowDetails = value
            cmdDetails.Visible = bShowDetails
        End Set
    End Property

    Private Sub ucStatusLine_Load(sender As Object, e As EventArgs) Handles Me.Load
        Try
            lblIcon.ImageIndex = LogStates.LSInfo
            lblStatus.Text = ""
        Catch ex As Exception
            Debug.Print(ex.Message)
        End Try
    End Sub

    Public Sub SetStatus(oStatus As ErrorDetail)
        oError = oStatus
        If Not oError.Ex Is Nothing Then
            Dim st As New StackTrace(oError.Ex, True)
            oError.Location &= " L " & st.GetFrame(0).GetFileLineNumber().ToString
        End If
        lblIcon.ImageIndex = oError.Status
        lblStatus.Text = oError.Summary
    End Sub

    Public Sub SetStatus(oState As LogStates, sText As String)
        oError = New ErrorDetail(oState, sText)
        lblIcon.ImageIndex = oState
        lblStatus.Text = sText
    End Sub

    Private Sub ErrorLog_ErrorLogged(oDetail As ErrorDetail) Handles ErrorLog.ErrorLogged
        SetStatus(oDetail)
    End Sub

    Private Sub ucStatusLine_Resize(sender As Object, e As EventArgs) Handles Me.Resize
        lblIcon.Height = Me.Height
        lblIcon.Width = Me.Height
    End Sub

    Private Sub cmdDetails_Click(sender As Object, e As EventArgs) Handles cmdDetails.Click
        Try
            If oError Is Nothing Then Exit Sub
            Dim sSummary As String = ""
            Select Case oError.Status
                Case LogStates.LSInfo
                    sSummary = "Info @ " & oError.Summary & vbCrLf
                Case LogStates.LSWarning
                    sSummary = "Warning @ " & oError.Summary & vbCrLf
                Case LogStates.LSError
                    sSummary = "Error @ " & oError.Summary & vbCrLf
                Case LogStates.LSClear
                    sSummary = "Clear @ " & oError.Summary & vbCrLf
            End Select
            sSummary &= "Detail: " & oError.Detail & vbCrLf &
                        "Location: " & oError.Location
            MsgBox(sSummary)
        Catch ex As Exception
            Debug.Print(ex.Message)
        End Try

    End Sub

    Private Sub cmdClear_Click(sender As Object, e As EventArgs) Handles cmdClear.Click
        oError = Nothing
        lblStatus.Text = ""
        lblIcon.ImageIndex = LogStates.LSInfo
    End Sub
End Class
