﻿Imports System.Runtime.InteropServices
Imports System.Diagnostics
Imports System.Text
Imports System.Reflection.MethodBase
Imports ErrorLog
Imports ErrorLog.LogStates
Imports System.Drawing.Color

Namespace API

#Region "Constants and Enums"

    Public Enum WndMsg
        WM_ACTIVATE = &H6
        WM_ACTIVATEAPP = &H1C
        WM_AFXFIRST = &H360
        WM_AFXLAST = &H37F
        WM_APP = &H8000
        WM_APPCOMMAND = &H319
        WM_ASKCBFORMATNAME = &H30C
        WM_CANCELJOURNAL = &H4B
        WM_CANCELMODE = &H1F
        WM_CAPTURECHANGED = &H215
        WM_CHANGECBCHAIN = &H30D
        WM_CHANGEUISTATE = &H127
        WM_CHAR = &H102
        WM_CHARTOITEM = &H2F
        WM_CHILDACTIVATE = &H22
        WM_CLEAR = &H303
        WM_CLOSE = &H10
        WM_COMMAND = &H111
        WM_COMPACTING = &H41
        WM_COMPAREITEM = &H39
        WM_CONTEXTMENU = &H7B
        WM_COPY = &H301
        WM_COPYDATA = &H4A
        WM_CREATE = &H1
        WM_CTLCOLORBTN = &H135
        WM_CTLCOLORDLG = &H136
        WM_CTLCOLOREDIT = &H133
        WM_CTLCOLORLISTBOX = &H134
        WM_CTLCOLORMSGBOX = &H132
        WM_CTLCOLORSCROLLBAR = &H137
        WM_CTLCOLORSTATIC = &H138
        WM_CUT = &H300
        WM_DEADCHAR = &H103
        WM_DELETEITEM = &H2D
        WM_DESTROY = &H2
        WM_DESTROYCLIPBOARD = &H307
        WM_DEVICECHANGE = &H219
        WM_DEVMODECHANGE = &H1B
        WM_DISPLAYCHANGE = &H7E
        WM_DRAWCLIPBOARD = &H308
        WM_DRAWITEM = &H2B
        WM_DROPFILES = &H233
        WM_ENABLE = &HA
        WM_ENDSESSION = &H16
        WM_ENTERIDLE = &H121
        WM_ENTERMENULOOP = &H211
        WM_ENTERSIZEMOVE = &H231
        WM_ERASEBKGND = &H14
        WM_EXITMENULOOP = &H212
        WM_EXITSIZEMOVE = &H232
        WM_FONTCHANGE = &H1D
        WM_GETDLGCODE = &H87
        WM_GETFONT = &H31
        WM_GETHOTKEY = &H33
        WM_GETICON = &H7F
        WM_GETMINMAXINFO = &H24
        WM_GETOBJECT = &H3D
        WM_GETTEXT = &HD
        WM_GETTEXTLENGTH = &HE
        WM_HANDHELDFIRST = &H358
        WM_HANDHELDLAST = &H35F
        WM_HELP = &H53
        WM_HOTKEY = &H312
        WM_HSCROLL = &H114
        WM_HSCROLLCLIPBOARD = &H30E
        WM_ICONERASEBKGND = &H27
        WM_IME_CHAR = &H286
        WM_IME_COMPOSITION = &H10F
        WM_IME_COMPOSITIONFULL = &H284
        WM_IME_CONTROL = &H283
        WM_IME_ENDCOMPOSITION = &H10E
        WM_IME_KEYDOWN = &H290
        WM_IME_KEYLAST = &H10F
        WM_IME_KEYUP = &H291
        WM_IME_NOTIFY = &H282
        WM_IME_REQUEST = &H288
        WM_IME_SELECT = &H285
        WM_IME_SETCONTEXT = &H281
        WM_IME_STARTCOMPOSITION = &H10D
        WM_INITDIALOG = &H110
        WM_INITMENU = &H116
        WM_INITMENUPOPUP = &H117
        WM_INPUTLANGCHANGE = &H51
        WM_INPUTLANGCHANGEREQUEST = &H50
        WM_KEYDOWN = &H100
        WM_KEYFIRST = &H100
        WM_KEYLAST = &H108
        WM_KEYUP = &H101
        WM_KILLFOCUS = &H8
        WM_LBUTTONDBLCLK = &H203
        WM_LBUTTONDOWN = &H201
        WM_LBUTTONUP = &H202
        WM_MBUTTONDBLCLK = &H209
        WM_MBUTTONDOWN = &H207
        WM_MBUTTONUP = &H208
        WM_MDIACTIVATE = &H222
        WM_MDICASCADE = &H227
        WM_MDICREATE = &H220
        WM_MDIDESTROY = &H221
        WM_MDIGETACTIVE = &H229
        WM_MDIICONARRANGE = &H228
        WM_MDIMAXIMIZE = &H225
        WM_MDINEXT = &H224
        WM_MDIREFRESHMENU = &H234
        WM_MDIRESTORE = &H223
        WM_MDISETMENU = &H230
        WM_MDITILE = &H226
        WM_MEASUREITEM = &H2C
        WM_MENUCHAR = &H120
        WM_MENUCOMMAND = &H126
        WM_MENUDRAG = &H123
        WM_MENUGETOBJECT = &H124
        WM_MENURBUTTONUP = &H122
        WM_MENUSELECT = &H11F
        WM_MOUSEACTIVATE = &H21
        WM_MOUSEFIRST = &H200
        WM_MOUSEHOVER = &H2A1
        WM_MOUSELAST = &H20D
        WM_MOUSELEAVE = &H2A3
        WM_MOUSEMOVE = &H200
        WM_MOUSEWHEEL = &H20A
        WM_MOUSEHWHEEL = &H20E
        WM_MOVE = &H3
        WM_MOVING = &H216
        WM_NCACTIVATE = &H86
        WM_NCCALCSIZE = &H83
        WM_NCCREATE = &H81
        WM_NCDESTROY = &H82
        WM_NCHITTEST = &H84
        WM_NCLBUTTONDBLCLK = &HA3
        WM_NCLBUTTONDOWN = &HA1
        WM_NCLBUTTONUP = &HA2
        WM_NCMBUTTONDBLCLK = &HA9
        WM_NCMBUTTONDOWN = &HA7
        WM_NCMBUTTONUP = &HA8
        WM_NCMOUSEHOVER = &H2A0
        WM_NCMOUSELEAVE = &H2A2
        WM_NCMOUSEMOVE = &HA0
        WM_NCPAINT = &H85
        WM_NCRBUTTONDBLCLK = &HA6
        WM_NCRBUTTONDOWN = &HA4
        WM_NCRBUTTONUP = &HA5
        WM_NCXBUTTONDBLCLK = &HAD
        WM_NCXBUTTONDOWN = &HAB
        WM_NCXBUTTONUP = &HAC
        WM_NCUAHDRAWCAPTION = &HAE
        WM_NCUAHDRAWFRAME = &HAF
        WM_NEXTDLGCTL = &H28
        WM_NEXTMENU = &H213
        WM_NOTIFY = &H4E
        WM_NOTIFYFORMAT = &H55
        WM_NULL = &H0
        WM_PAINT = &HF
        WM_PAINTCLIPBOARD = &H309
        WM_PAINTICON = &H26
        WM_PALETTECHANGED = &H311
        WM_PALETTEISCHANGING = &H310
        WM_PARENTNOTIFY = &H210
        WM_PASTE = &H302
        WM_PENWINFIRST = &H380
        WM_PENWINLAST = &H38F
        WM_POWER = &H48
        WM_POWERBROADCAST = &H218
        WM_PRINT = &H317
        WM_PRINTCLIENT = &H318
        WM_QUERYDRAGICON = &H37
        WM_QUERYENDSESSION = &H11
        WM_QUERYNEWPALETTE = &H30F
        WM_QUERYOPEN = &H13
        WM_QUEUESYNC = &H23
        WM_QUIT = &H12
        WM_RBUTTONDBLCLK = &H206
        WM_RBUTTONDOWN = &H204
        WM_RBUTTONUP = &H205
        WM_RENDERALLFORMATS = &H306
        WM_RENDERFORMAT = &H305
        WM_SETCURSOR = &H20
        WM_SETFOCUS = &H7
        WM_SETFONT = &H30
        WM_SETHOTKEY = &H32
        WM_SETICON = &H80
        WM_SETREDRAW = &HB
        WM_SETTEXT = &HC
        WM_SETTINGCHANGE = &H1A
        WM_SHOWWINDOW = &H18
        WM_SIZE = &H5
        WM_SIZECLIPBOARD = &H30B
        WM_SIZING = &H214
        WM_SPOOLERSTATUS = &H2A
        WM_STYLECHANGED = &H7D
        WM_STYLECHANGING = &H7C
        WM_SYNCPAINT = &H88
        WM_SYSCHAR = &H106
        WM_SYSCOLORCHANGE = &H15
        WM_SYSCOMMAND = &H112
        WM_SYSDEADCHAR = &H107
        WM_SYSKEYDOWN = &H104
        WM_SYSKEYUP = &H105
        WM_TCARD = &H52
        WM_TIMECHANGE = &H1E
        WM_TIMER = &H113
        WM_UNDO = &H304
        WM_UNINITMENUPOPUP = &H125
        WM_USER = &H400
        WM_USERCHANGED = &H54
        WM_VKEYTOITEM = &H2E
        WM_VSCROLL = &H115
        WM_VSCROLLCLIPBOARD = &H30A
        WM_WINDOWPOSCHANGED = &H47
        WM_WINDOWPOSCHANGING = &H46
        WM_WININICHANGE = &H1A
        WM_XBUTTONDBLCLK = &H20D
        WM_XBUTTONDOWN = &H20B
        WM_XBUTTONUP = &H20C
        EM_FNTLINES = (WM_USER + 24)
        EM_GETLINECOUNT = WM_USER + 10
        EM_GETLINE = WM_USER + 20
        EM_GETRECT = WM_USER + 2
        EM_SETRECT = WM_USER + 3
        EM_SETTABSTOPS = WM_USER + 27
        EM_SETREADONLY = (WM_USER + 31)
        EM_UNDO = WM_USER + 23
        EM_REPLACESEL = &HC2
        BM_CLICK = &HF5
        CB_GETEDITSEL = &H140
        CB_LIMITTEXT = &H141
        CB_SETEDITSEL = &H142
        CB_ADDSTRING = &H143
        CB_DELETESTRING = &H144
        CB_DIR = &H145
        CB_GETCOUNT = &H146
        CB_GETCURSEL = &H147
        CB_GETLBTEXT = &H148
        CB_GETLBTEXTLEN = &H149
        CB_INSERTSTRING = &H14A
        CB_RESETCONTENT = &H14B
        CB_FINDSTRING = &H14C
        CB_SELECTSTRING = &H14D
        CB_SETCURSEL = &H14E
        CB_SHOWDROPDOWN = &H14F
        CB_GETITEMDATA = &H150
        CB_SETITEMDATA = &H151
        CB_GETDROPPEDCONTROLRECT = &H152
        CB_SETITEMHEIGHT = &H153
        CB_GETITEMHEIGHT = &H154
        CB_SETEXTENDEDUI = &H155
        CB_GETEXTENDEDUI = &H156
        CB_GETDROPPEDSTATE = &H157
        CB_FINDSTRINGEXACT = &H158
        CB_SETLOCALE = &H159
        CB_GETLOCALE = &H15A
        CB_GETTOPINDEX = &H15B
        CB_SETTOPINDEX = &H15C
        CB_GETHORIZONTALEXTENT = &H15D
        CB_SETHORIZONTALEXTENT = &H15E
        CB_GETDROPPEDWIDTH = &H15F
        CB_SETDROPPEDWIDTH = &H160
        CB_INITSTORAGE = &H161
        CB_MSGMAX = &H162
        GW_HWNDFIRST = 0
        GW_HWNDLAST = 1
        GW_HWNDNEXT = 2
        GW_HWNDPREV = 3
        GW_OWNER = 4
        GW_CHILD = 5
        GW_ENABLEDPOPUP = 6
    End Enum

    <Flags()>
    Public Enum SetWindowPosFlags As UInteger
        ''' <summary>If the calling thread and the thread that owns the window are attached to different input queues, 
        ''' the system posts the request to the thread that owns the window. This prevents the calling thread from 
        ''' blocking its execution while other threads process the request.</summary>
        ''' <remarks>SWP_ASYNCWINDOWPOS</remarks>
        SynchronousWindowPosition = &H4000
        ''' <summary>Prevents generation of the WM_SYNCPAINT message.</summary>
        ''' <remarks>SWP_DEFERERASE</remarks>
        DeferErase = &H2000
        ''' <summary>Draws a frame (defined in the window's class description) around the window.</summary>
        ''' <remarks>SWP_DRAWFRAME</remarks>
        DrawFrame = &H20
        ''' <summary>Applies new frame styles set using the SetWindowLong function. Sends a WM_NCCALCSIZE message to 
        ''' the window, even if the window's size is not being changed. If this flag is not specified, WM_NCCALCSIZE 
        ''' is sent only when the window's size is being changed.</summary>
        ''' <remarks>SWP_FRAMECHANGED</remarks>
        FrameChanged = &H20
        ''' <summary>Hides the window.</summary>
        ''' <remarks>SWP_HIDEWINDOW</remarks>
        HideWindow = &H80
        ''' <summary>Does not activate the window. If this flag is not set, the window is activated and moved to the 
        ''' top of either the topmost or non-topmost group (depending on the setting of the hWndInsertAfter 
        ''' parameter).</summary>
        ''' <remarks>SWP_NOACTIVATE</remarks>
        DoNotActivate = &H10
        ''' <summary>Discards the entire contents of the client area. If this flag is not specified, the valid 
        ''' contents of the client area are saved and copied back into the client area after the window is sized or 
        ''' repositioned.</summary>
        ''' <remarks>SWP_NOCOPYBITS</remarks>
        DoNotCopyBits = &H100
        ''' <summary>Retains the current position (ignores X and Y parameters).</summary>
        ''' <remarks>SWP_NOMOVE</remarks>
        IgnoreMove = &H2
        ''' <summary>Does not change the owner window's position in the Z order.</summary>
        ''' <remarks>SWP_NOOWNERZORDER</remarks>
        DoNotChangeOwnerZOrder = &H200
        ''' <summary>Does not redraw changes. If this flag is set, no repainting of any kind occurs. This applies to 
        ''' the client area, the nonclient area (including the title bar and scroll bars), and any part of the parent 
        ''' window uncovered as a result of the window being moved. When this flag is set, the application must 
        ''' explicitly invalidate or redraw any parts of the window and parent window that need redrawing.</summary>
        ''' <remarks>SWP_NOREDRAW</remarks>
        DoNotRedraw = &H8
        ''' <summary>Same as the SWP_NOOWNERZORDER flag.</summary>
        ''' <remarks>SWP_NOREPOSITION</remarks>
        DoNotReposition = &H200
        ''' <summary>Prevents the window from receiving the WM_WINDOWPOSCHANGING message.</summary>
        ''' <remarks>SWP_NOSENDCHANGING</remarks>
        DoNotSendChangingEvent = &H400
        ''' <summary>Retains the current size (ignores the cx and cy parameters).</summary>
        ''' <remarks>SWP_NOSIZE</remarks>
        IgnoreResize = &H1
        ''' <summary>Retains the current Z order (ignores the hWndInsertAfter parameter).</summary>
        ''' <remarks>SWP_NOZORDER</remarks>
        IgnoreZOrder = &H4
        ''' <summary>Displays the window.</summary>
        ''' <remarks>SWP_SHOWWINDOW</remarks>
        ShowWindow = &H40
    End Enum


    Public Enum ShowWindowCommands As Integer
        ''' <summary>
        ''' Hides the window and activates another window.
        ''' </summary>
        Hide = 0
        ''' <summary>
        ''' Activates and displays a window. If the window is minimized or
        ''' maximized, the system restores it to its original size and position.
        ''' An application should specify this flag when displaying the window
        ''' for the first time.
        ''' </summary>
        Normal = 1
        ''' <summary>
        ''' Activates the window and displays it as a minimized window.
        ''' </summary>
        ShowMinimized = 2
        ''' <summary>
        ''' Maximizes the specified window.
        ''' </summary>
        Maximize = 3
        ' is this the right value?
        ''' <summary>
        ''' Activates the window and displays it as a maximized window.
        ''' </summary>      
        ShowMaximized = 3
        ''' <summary>
        ''' Displays a window in its most recent size and position. This value
        ''' is similar to see cref="Win32.ShowWindowCommands.Normal"/, except
        ''' the window is not actived.
        ''' </summary>
        ShowNoActivate = 4
        ''' <summary>
        ''' Activates the window and displays it in its current size and position.
        ''' </summary>
        Show = 5
        ''' <summary>
        ''' Minimizes the specified window and activates the next top-level
        ''' window in the Z order.
        ''' </summary>
        Minimize = 6
        ''' <summary>
        ''' Displays the window as a minimized window. This value is similar to
        ''' <see cref="Win32.ShowWindowCommands.ShowMinimized"/>, except the
        ''' window is not activated.
        ''' </summary>
        ShowMinNoActive = 7
        ''' <summary>
        ''' Displays the window in its current size and position. This value is
        ''' similar to <see cref="Win32.ShowWindowCommands.Show"/>, except the
        ''' window is not activated.
        ''' </summary>
        ShowNA = 8
        ''' <summary>
        ''' Activates and displays the window. If the window is minimized or
        ''' maximized, the system restores it to its original size and position.
        ''' An application should specify this flag when restoring a minimized window.
        ''' </summary>
        Restore = 9
        ''' <summary>
        ''' Sets the show state based on the SW_* value specified in the
        ''' STARTUPINFO structure passed to the CreateProcess function by the
        ''' program that started the application.
        ''' </summary>
        ShowDefault = 10
        ''' <summary>
        '''  <b>Windows 2000/XP:</b> Minimizes a window, even if the thread
        ''' that owns the window is not responding. This flag should only be
        ''' used when minimizing windows from a different thread.
        ''' </summary>
        ForceMinimize = 11
    End Enum

    Public Enum SetWindowPosConst As Integer
        HWND_BOTTOM = 1
        HWND_NOTOPMOST = -2
        HWND_TOP = 0
        HWND_TOPMOST = -1
    End Enum

    <Flags()>
    Public Enum SendMessageTimeoutFlags
        SMTO_NORMAL = 0
        SMTO_BLOCK = 1
        SMTO_ABORTIFHUNG = 2
        SMTO_NOTIMEOUTIFNOTHUNG = 8
        SMTO_ERRORONEXIT = 32
    End Enum

#End Region

#Region "Structures"

    ' http://msdn.microsoft.com/library/default.asp?url=/library/en-us/shellcc/platform/commctls/tooltip/structures/toolinfo.asp
    <StructLayout(LayoutKind.Sequential)>
    Public Structure TOOLINFO
        Public cbSize As Integer
        Public uFlags As Integer
        Public hwnd As IntPtr
        Public uId As IntPtr
        Public rect As RECT
        Public hinst As IntPtr
        <MarshalAs(UnmanagedType.LPTStr)>
        Public lpszText As String
        Public lParam As System.UInt32
    End Structure

    ' http://msdn.microsoft.com/library/default.asp?url=/library/en-us/gdi/rectangl_6cqa.asp
    <StructLayout(LayoutKind.Sequential)>
    Public Structure RECT
        Public left As Integer
        Public top As Integer
        Public right As Integer
        Public bottom As Integer
    End Structure

    'http://msdn.microsoft.com/library/default.asp?url=/library/en-us/power/base/system_power_status_str.asp
    <StructLayout(LayoutKind.Sequential)>
    Public Structure SYSTEM_POWER_STATUS

        Public ACLineStatus As Byte  ' One of the ACLineStatus values
        Public BatteryFlag As Byte  ' One of the BatteryFlag values
        Public BatteryLifePercent As Byte ' 0-100, or 255 if the status is unknown
        Public Reserved1 As Byte           ' must be 0
        Public BatteryLifeTime As Integer  'seconds of battery life remaining, or –1 if unknown
        Public BatteryFullLifeTime As Integer ' seconds of battery life when at full charge, or –1 if unknown

    End Structure

    Public Structure POINTAPI
        Public x As Integer
        Public y As Integer
    End Structure

    Public Structure MSG
        Public hWnd As Long
        Public message As Long
        Public wParam As Long
        Public lParam As Long
        Public time As Long
        Public pt As POINTAPI
    End Structure

    Public Structure DROPFILES
        Public pFiles As Integer
        Public pt As POINTAPI
        Public fNC As Byte
        Public fWide As Byte
    End Structure

    Public Structure DROPLISTS
        Public pDrop As DROPFILES
        Public pFName As String
        Public pfnull As String
    End Structure

    <StructLayout(LayoutKind.Sequential)>
    Public Structure LASTINPUTINFO
        <MarshalAs(UnmanagedType.U4)> Public cbSize As Integer
        <MarshalAs(UnmanagedType.U4)> Public dwTime As Integer
    End Structure
#End Region

    Public Class CAPI
        Private sModule As String = "CAPI"
        Public Event ErrorRaised(oDetail As ErrorDetail)

        <DllImport("user32.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
        Public Shared Function FindWindow(ByVal lpClassName As String, ByVal lpWindowName As String) As IntPtr
        End Function
        <DllImport("user32.dll", EntryPoint:="FindWindow", SetLastError:=True, CharSet:=CharSet.Auto)>
        Public Shared Function FindWindowByClass(ByVal lpClassName As String, ByVal zero As IntPtr) As IntPtr
        End Function
        <DllImport("user32.dll", EntryPoint:="FindWindow", SetLastError:=True, CharSet:=CharSet.Auto)>
        Public Shared Function FindWindowByCaption(ByVal zero As IntPtr, ByVal lpWindowName As String) As IntPtr
        End Function
        <DllImport("user32.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
        Public Shared Function FindWindowEx(ByVal parentHandle As IntPtr, ByVal childAfter As IntPtr, ByVal lclassName As String, ByVal windowTitle As String) As IntPtr
        End Function
        <DllImport("user32.dll", ExactSpelling:=True, CharSet:=CharSet.Auto)>
        Public Shared Function GetParent(ByVal hWnd As IntPtr) As IntPtr
        End Function
        <DllImport("user32.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
        Public Shared Function GetWindow(ByVal hWnd As IntPtr, ByVal msg As WndMsg) As IntPtr
        End Function
        Public Declare Auto Function GetClassName Lib "User32.dll" (ByVal hwnd As IntPtr, <Out()> ByVal lpClassName As System.Text.StringBuilder, ByVal nMaxCount As Integer) As Integer
        <DllImport("user32.dll", SetLastError:=True)>
        Public Shared Function LockWorkStation() As Boolean
        End Function

        <DllImport("user32.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
        Public Shared Function SendMessage(ByVal hWnd As IntPtr, ByVal Msg As WndMsg, ByVal wParam As IntPtr, ByVal lParam As IntPtr) As IntPtr
        End Function
        <DllImport("user32.dll", SetLastError:=True, CharSet:=CharSet.Auto, EntryPoint:="SendMessage")>
        Public Shared Function SendMessageByString(ByVal hWnd As IntPtr, ByVal Msg As WndMsg, ByVal wParam As IntPtr, ByVal lParam As String) As IntPtr
        End Function
        <DllImport("user32.dll", SetLastError:=True, CharSet:=CharSet.Auto, EntryPoint:="SendMessageA")>
        Public Shared Function SendMessageByObject(ByVal hWnd As IntPtr, ByVal Msg As WndMsg, ByVal wParam As IntPtr, ByVal lParam As Object) As IntPtr
        End Function
        <DllImport("user32.dll", SetLastError:=True)>
        Public Shared Function SendMessageTimeout(ByVal windowHandle As IntPtr, ByVal Msg As Integer, ByVal wParam As IntPtr, ByVal lParam As IntPtr, ByVal flags As SendMessageTimeoutFlags, ByVal timeout As Integer, ByRef result As IntPtr) As IntPtr
        End Function
        <DllImport("user32.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
        Public Shared Function SetActiveWindow(ByVal hWnd As IntPtr) As IntPtr
        End Function
        <DllImport("user32.dll")>
        Public Shared Function GetLastInputInfo(ByRef plii As LASTINPUTINFO) As Boolean
        End Function

        <DllImport("user32.dll", EntryPoint:="GetWindowText")>
        Public Shared Function GetWindowText(ByVal hwnd As Integer, ByVal lpString As System.Text.StringBuilder, ByVal cch As Integer) As Integer
        End Function
        <DllImport("user32.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
        Public Shared Function GetWindowTextLength(ByVal hwnd As IntPtr) As Integer
        End Function
        <DllImport("user32.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
        Public Shared Function ShowWindow(ByVal hwnd As IntPtr, ByVal nCmdShow As ShowWindowCommands) As Boolean
        End Function

        <DllImport("kernel32", CharSet:=CharSet.Ansi)>
        Public Shared Function GlobalAlloc(ByVal wFlags As Integer, ByVal dwBytes As Integer) As Integer
        End Function

        <DllImport("kernel32", CharSet:=CharSet.Ansi)>
        Public Shared Function GlobalFree(ByVal hMem As Integer) As Integer
        End Function

        <DllImport("kernel32", CharSet:=CharSet.Ansi)>
        Public Shared Function GlobalLock(ByVal hMem As Integer) As Integer
        End Function

        <DllImport("kernel32", CharSet:=CharSet.Ansi)>
        Public Shared Function GlobalUnlock(ByVal hMem As Integer) As Integer
        End Function

        <DllImport("kernel32", CharSet:=CharSet.Ansi)>
        Public Shared Sub MoveMemory(ByVal Destination As Integer, ByVal Source As Integer, ByVal Length As Integer)
        End Sub

        <DllImport("kernel32.dll", CharSet:=CharSet.Ansi)>
        Public Overloads Shared Sub CopyMemory(ByVal Destination As Integer, ByVal Source As Integer, ByVal Length As Integer)
        End Sub

        <DllImport("kernel32.dll", CharSet:=CharSet.Ansi)>
        Public Overloads Shared Sub CopyMemory(ByVal Destination As Integer, ByVal Source As String, ByVal Length As Integer)
        End Sub

        <DllImport("kernel32.dll", CharSet:=CharSet.Ansi)>
        Public Overloads Shared Sub CopyMemory(ByVal Destination As IntPtr, ByVal Source As DROPLISTS, ByVal Length As Integer)
        End Sub

        ' http://msdn.microsoft.com/library/default.asp?url=/library/en-us/winui/winui/windowsuserinterface/windowing/windows/windowreference/windowfunctions/getclientrect.asp
        <DllImport("User32", SetLastError:=True)>
        Public Shared Function GetClientRect(ByVal hWnd As IntPtr, ByRef lpRect As RECT) As Integer
        End Function

        ' http://msdn.microsoft.com/library/default.asp?url=/library/en-us/gdi/cordspac_2tny.asp
        <DllImport("User32", SetLastError:=True)>
        Public Shared Function ClientToScreen(ByVal hWnd As IntPtr, ByRef lpRect As RECT) As Integer
        End Function

        ' http://msdn.microsoft.com/library/default.asp?url=/library/en-us/winui/winui/windowsuserinterface/windowing/windows/windowreference/windowfunctions/setwindowpos.asp
        <DllImport("User32", SetLastError:=True)>
        Public Shared Function SetWindowPos(ByVal hWnd As IntPtr, ByVal hWndInsertAfter As SetWindowPosConst, ByVal X As Integer, ByVal Y As Integer, ByVal cx As Integer, ByVal cy As Integer, ByVal uFlags As SetWindowPosFlags) As Boolean
        End Function

        <DllImport("shell32", SetLastError:=True)>
        Public Shared Function SHQueryUserNotificationState(ByRef result As IntPtr) As Integer
        End Function

        ' http://msdn.microsoft.com/library/default.asp?url=/library/en-us/sysinfo/base/systemparametersinfo.asp
        <DllImport("user32")>
        Public Shared Function SystemParametersInfo(ByVal uAction As Integer,
            ByVal uParam As Integer, ByVal lpvParam As String, ByVal fuWinIni As Integer) As Integer
        End Function

        Public Shared Function MAKELONG(ByVal loWord As Integer, ByVal hiWord As Integer) As Integer
            Return (hiWord << 16) Or (loWord And &HFFFF)
        End Function

        ' http://msdn.microsoft.com/library/default.asp?url=/library/en-us/winui/winui/windowsuserinterface/resources/icons/iconreference/iconfunctions/extracticonex.asp
        <DllImport("Shell32.dll", EntryPoint:="ExtractIconExW", CharSet:=CharSet.Unicode, ExactSpelling:=True, CallingConvention:=Runtime.InteropServices.CallingConvention.StdCall)>
        Public Shared Function ExtractIconEx(ByVal sFile As String, ByVal iIndex As Integer, ByRef piLargeVersion As IntPtr, ByRef piSmallVersion As IntPtr, ByVal amountIcons As Integer) As Integer
        End Function

        ' http://msdn.microsoft.com/library/default.asp?url=/library/en-us/power/base/getsystempowerstatus.asp
        <DllImport("kernel32.dll", CharSet:=CharSet.Ansi)>
        Public Shared Function GetSystemPowerStatus(ByRef lpSystemPowerStatus As SYSTEM_POWER_STATUS) As Boolean
        End Function

        Public Declare Function AbortSystemShutdown Lib "advapi32.dll" Alias "AbortSystemShutdownA" (ByVal lpMachineName As String) As Integer
        'Public Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, ByVal lpFindFileData As WIN32_FIND_DATA) As Integer
        'Public Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Integer, ByVal lpFindFileData As WIN32_FIND_DATA) As Integer
        Public Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Integer) As Integer
        Public Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWndParent As Integer, ByVal hWndChildAfter As Integer, ByVal lpClassName As String, ByVal lpWindowName As String) As Integer
        Public Declare Function InitiateSystemShutdown Lib "advapi32.dll" Alias "InitiateSystemShutdownA" (ByVal lpMachineName As String, ByVal lpMessage As String, ByVal dwTimeout As Integer, ByVal bForceAppsClosed As Integer, ByVal bRebootAfterShutdown As Integer) As Integer
        Public Declare Function GetCurrentTime Lib "kernel32" Alias "GetTickCount" () As Integer
        Public Declare Function GetDesktopWindow Lib "user32" () As Integer
        Public Declare Function GetFileVersionInfo Lib "version.dll" Alias "GetFileVersionInfoA" (ByVal lptstrFilename As String, ByVal dwHandle As Integer, ByVal dwLen As Integer, ByVal lpData As Byte) As Integer
        Public Declare Function GetFileVersionInfoSize Lib "version.dll" Alias "GetFileVersionInfoSizeA" (ByVal lptstrFilename As String, ByVal lpdwHandle As Integer) As Integer
        Public Declare Function GetNextWindow Lib "user32" (ByVal hwnd As Integer, ByVal wFlag As Integer) As Integer
        Private Declare Function GetPrivateProfileStringX Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpAppName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As StringBuilder, ByVal nSize As Integer, ByVal lpFileName As String) As Integer
        Public Declare Function GetSysColor Lib "user32" (ByVal nIndex As Integer) As Integer
        Public Declare Function GetTickCount Lib "kernel32" () As Integer
        Public Declare Function GetWindow Lib "user32" (ByVal hwnd As Integer, ByVal wCmd As Integer) As Integer
        Public Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Integer, ByVal lpString As String, ByVal cch As Integer) As Integer
        Public Declare Function KillTimer& Lib "user32" (ByVal hwnd&, ByVal nIDEvent&)
        'Public Declare Function OpenFile Lib "kernel32" (ByVal lpFileName As String, ByVal lpReOpenBuff As OFSTRUCT, ByVal wStyle As Integer) As Integer
        Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, ByVal lParam As Object) As Integer
        Public Declare Function SendMessageBynum Lib "user32" Alias "SendMessageA" (ByVal hwnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, ByVal lParam As Integer) As Integer
        Public Declare Function SendMessageByString Lib "user32" Alias "SendMessageA" (ByVal hwnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, ByVal lParam As String) As Integer
        Public Declare Function SetActiveWindow Lib "user32" (ByVal hwnd As Integer) As Integer
        Public Declare Function SetFocusAPI Lib "user32" Alias "SetFocus" (ByVal hwnd As Integer) As Integer
        Public Declare Function SetTimer& Lib "user32" (ByVal hwnd&, ByVal nIDEvent&, ByVal uElapse&, ByVal lpTimerFunc&)
        'Public Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Integer, ByVal hWndInsertAfter As Integer, ByVal x As Integer, ByVal y As Integer, ByVal cx As Integer, ByVal cy As Integer, ByVal wFlags As Integer) As Integer
        Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Integer, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Integer) As Integer
        Public Declare Function timeKillEvent Lib "winmm.dll" (ByVal uID As Long) As Long
        Public Declare Function timeSetEvent Lib "winmm.dll" (ByVal uDelay As Long, ByVal uResolution As Long, ByVal lpFunction As Long, ByVal dwUser As Long, ByVal uFlags As Long) As Long
        Public Declare Function VerQueryValue Lib "version.dll" Alias "VerQueryValueA" (ByVal pBlock As Byte, ByVal lpSubBlock As String, ByVal lpBuffer As Integer, ByVal puLen As Integer) As Integer
        Public Declare Function WinHelp Lib "user32" Alias "WinHelpA" (ByVal hwnd As Integer, ByVal lpHelpFile As String, ByVal wCommand As Integer, ByVal dwData As Integer) As Integer
        Public Declare Function WNetAddConnection& Lib "mpr.dll" Alias "WNetAddConnectionA" (ByVal lpszNetPath As String, ByVal lpszPassword As String, ByVal lpszLocalName As String)
        Public Declare Function WNetCancelConnection& Lib "mpr.dll" Alias "WNetCancelConnectionA" (ByVal lpszName As String, ByVal bForce As Integer)
        Public Declare Function WNetGetConnection& Lib "mpr.dll" Alias "WNetGetConnectionA" (ByVal lpszLocalName As String, ByVal lpszRemoteName As String, ByVal cbRemoteName As Integer)
        Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As String, ByVal lpFileName As String) As Integer
        ' Registry API prototypes
        Public Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Integer) As Integer
        Public Declare Function RegConnectRegistry Lib "advapi32.dll" Alias "RegConnectRegistryA" (ByVal lpMachineName As String, ByVal hKey As Integer, ByVal phkResult As Integer) As Integer
        Public Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Integer, ByVal lpSubKey As String, ByVal phkResult As Integer) As Integer
        'Public Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Integer, ByVal lpSubKey As String, ByVal reserved As Integer, ByVal lpClass As String, ByVal dwOptions As Integer, ByVal samDesired As Integer, ByVal lpSecurityAttributes As SECURITY_ATTRIBUTES, ByVal phkResult As Integer, ByVal lpdwDisposition As Integer) As Integer
        Public Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Integer, ByVal lpSubKey As String) As Integer
        Public Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Integer, ByVal lpValueName As String) As Integer
        Public Declare Function RegEnumKey Lib "advapi32.dll" Alias "RegEnumKeyA" (ByVal hKey As Integer, ByVal dwIndex As Integer, ByVal lpName As String, ByVal cbName As Integer) As Integer
        Public Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" (ByVal hKey As Integer, ByVal dwIndex As Integer, ByVal lpName As String, ByVal lpcbName As Integer, ByVal lpReserved As Integer, ByVal lpClass As String, ByVal lpcbClass As Integer, ByVal lpftLastWriteTime As ComTypes.FILETIME) As Integer
        'Public Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Integer, ByVal dwIndex As Integer, ByVal lpValueName As String, ByVal lpcbValueName As Integer, ByVal lpReserved As Integer, ByVal lp Structure As Integer, ByVal lpData As Any, ByVal lpcbData As Integer) As Integer
        Public Declare Function RegFlushKey Lib "advapi32.dll" (ByVal hKey As Integer) As Integer
        'Public Declare Function RegGetKeySecurity Lib "advapi32.dll" (ByVal hKey As Integer, ByVal SecurityInformation As Integer, ByVal pSecurityDescriptor As SECURITY_DESCRIPTOR, ByVal lpcbSecurityDescriptor As Integer) As Integer
        Public Declare Function RegLoadKey Lib "advapi32.dll" Alias "RegLoadKeyA" (ByVal hKey As Integer, ByVal lpSubKey As String, ByVal lpFile As String) As Integer
        Public Declare Function RegNotifyChangeKeyValue Lib "advapi32.dll" (ByVal hKey As Integer, ByVal bWatchSubtree As Integer, ByVal dwNotifyFilter As Integer, ByVal hEvent As Integer, ByVal fAsynchronus As Integer) As Integer
        Public Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Integer, ByVal lpSubKey As String, ByVal phkResult As Integer) As Integer
        Public Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Integer, ByVal lpSubKey As String, ByVal ulOptions As Integer, ByVal samDesired As Integer, ByVal phkResult As Integer) As Integer
        Public Declare Function RegQueryInfoKey Lib "advapi32.dll" Alias "RegQueryInfoKeyA" (ByVal hKey As Integer, ByVal lpClass As String, ByVal lpcbClass As Integer, ByVal lpReserved As Integer, ByVal lpcSubKeys As Integer, ByVal lpcbMaxSubKeyLen As Integer, ByVal lpcbMaxClassLen As Integer, ByVal lpcValues As Integer, ByVal lpcbMaxValueNameLen As Integer, ByVal lpcbMaxValueLen As Integer, ByVal lpcbSecurityDescriptor As Integer, ByVal lpftLastWriteTime As ComTypes.FILETIME) As Integer
        Public Declare Function RegQueryValue Lib "advapi32.dll" Alias "RegQueryValueA" (ByVal hKey As Integer, ByVal lpSubKey As String, ByVal lpValue As String, ByVal lpcbValue As Integer) As Integer
        'Public Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Integer, ByVal lpValueName As String, ByVal lpReserved As Integer, ByVal lp Structure As Integer, ByVal lpData As Any, ByVal lpcbData As Integer) As Integer ' Note that if you declare the lpData parameter as String, you must pass it By Value.
        Public Declare Function RegReplaceKey Lib "advapi32.dll" Alias "RegReplaceKeyA" (ByVal hKey As Integer, ByVal lpSubKey As String, ByVal lpNewFile As String, ByVal lpOldFile As String) As Integer
        Public Declare Function RegRestoreKey Lib "advapi32.dll" Alias "RegRestoreKeyA" (ByVal hKey As Integer, ByVal lpFile As String, ByVal dwFlags As Integer) As Integer
        'Public Declare Function RegSaveKey Lib "advapi32.dll" Alias "RegSaveKeyA" (ByVal hKey As Integer, ByVal lpFile As String, ByVal lpSecurityAttributes As SECURITY_ATTRIBUTES) As Integer
        'Public Declare Function RegSetKeySecurity Lib "advapi32.dll" (ByVal hKey As Integer, ByVal SecurityInformation As Integer, ByVal pSecurityDescriptor As SECURITY_DESCRIPTOR) As Integer
        'Public Declare Function RegSetValue Lib "advapi32.dll" Alias "RegSetValueA" (ByVal hKey As Integer, ByVal lpSubKey As String, ByVal dw Structure As Integer, ByVal lpData As String, ByVal cbData As Integer) As Integer
        'Public Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Integer, ByVal lpValueName As String, ByVal reserved As Integer, ByVal dw Structure As Integer, ByVal lpData As String, ByVal cbData As Integer) As Integer   ' Note that if you declare the lpData parameter as String, you must pass it By Value.
        Public Declare Function RegUnLoadKey Lib "advapi32.dll" Alias "RegUnLoadKeyA" (ByVal hKey As Integer, ByVal lpSubKey As String) As Integer


        Public Shared Function GetPrivateProfileString(sApplication As String, sKeyName As String, sDefault As String, sFileName As String) As String
            Dim sBuffer As New StringBuilder(500)
            Dim lRet As Integer

            lRet = GetPrivateProfileStringX(sApplication, sKeyName, sDefault, sBuffer, sBuffer.Capacity, sFileName)
            Return sBuffer.ToString
        End Function

        Public Shared Function APIErrorToString(ByRef lError As Integer) As String
            Try
                Dim FORMAT_MESSAGE_FROM_SYSTEM As Object
                Dim FormatMessage As Object

                Dim sErrorMsg, sSysMsg As String
                Dim lMsgSize As Integer

                lMsgSize = 1000 ' Make buffer large enough for message
                sSysMsg = Space(lMsgSize)

                'UPGRADE_WARNING: Couldn't resolve default property of object FormatMessage(). Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
                lMsgSize = FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, 0, lError, 0, sSysMsg, lMsgSize, 0)
                ' Get the error's description
                ' Function returns number of characters in string; 0=function failed
                If lMsgSize = 0 Then
                    APIErrorToString = "System error code: " & Str(lError)
                Else
                    APIErrorToString = Left(sSysMsg, lMsgSize)
                    ' Resize the string for output
                End If
            Catch ex As Exception
                Throw New Exception("CAPI." & GetCurrentMethod().Name & ":" & ex.Message, ex)
            End Try
        End Function

        ' Encapsulate the magic numbers for the return value in an enumeration
        Public Enum ReturnCodes As Integer
            DISP_CHANGE_SUCCESSFUL = 0
            DISP_CHANGE_BADDUALVIEW = -6
            DISP_CHANGE_BADFLAGS = -4
            DISP_CHANGE_BADMODE = -2
            DISP_CHANGE_BADPARAM = -5
            DISP_CHANGE_FAILED = -1
            DISP_CHANGE_NOTUPDATED = -3
            DISP_CHANGE_RESTART = 1
        End Enum

        ' Display / application status return values
        Public Enum NotificationStates As Integer
            QUNS_NOT_PRESENT = 1
            QUNS_BUSY = 2
            QUNS_RUNNING_D3D_FULL_SCREEN = 3
            QUNS_PRESENTATION_MODE = 4
            QUNS_ACCEPTS_NOTIFICATIONS = 5
            QUNS_QUIET_TIME = 6
            QUNS_APP = 7
        End Enum

        Public Shared Function LastInputTime() As Integer
            Try
                ' Returns Time of Last Input in Seconds
                Dim iIdleTime As Integer
                Dim oLastInput As New LASTINPUTINFO
                oLastInput.cbSize = Marshal.SizeOf(oLastInput) ' Look at how long we have been idle
                oLastInput.dwTime = 0
                If GetLastInputInfo(oLastInput) Then
                    iIdleTime = (Environment.TickCount - oLastInput.dwTime) / 1000
                End If
                Return iIdleTime
            Catch ex As Exception
                Throw New Exception("CAPI." & GetCurrentMethod().Name & ":" & ex.Message, ex)
            End Try
        End Function

        Public Shared Function GetUserNotificationState() As NotificationStates
            Dim iRet As Integer, iValue As Integer
            iRet = SHQueryUserNotificationState(iValue)
            Return iValue
        End Function
    End Class

    Public NotInheritable Class HotKeyRegistryClass
        Private Declare Function RegisterHotKey Lib "user32.dll" (ByVal handle As IntPtr, ByVal id As Int32, ByVal fsModifier As Int32, ByVal vk As Int32) As Int32
        Private Declare Function UnregisterHotKey Lib "user32.dll" (ByVal handle As IntPtr, ByVal id As Int32) As Int32
        Private Handle As IntPtr = IntPtr.Zero
        Private Registry As New System.Collections.Generic.List(Of Int32)
        Public Enum Messages
            [WM_HOTKEY] = &H312
        End Enum
        Public Enum Modifiers
            [MOD_ALT] = &H1
            [MOD_CTRL] = &H2
            [MOD_SHIFT] = &H4
            [MOD_WIN] = &H8
        End Enum
        Sub New(ByVal Handle As IntPtr)
            Me.Handle = Handle
        End Sub
        Public Function Register(ByVal Modifier As Int32, ByVal Key As System.Windows.Forms.Keys) As Int32
            Dim ret As Int32
            ret = NextAvailableIndex()
            Call RegisterHotKey(Me.Handle, ret, Modifier, Key)
            Registry.Insert(ret, ret)
            Return ret
        End Function
        Public Sub Unregister(ByVal ID As Int32)
            Call UnregisterHotKey(Me.Handle, ID)
            Registry.Remove(ID)
        End Sub
        Private Function NextAvailableIndex() As Int32
            Dim ret As Int32 = 0
            Dim n As Int32 = 0
            For i As Int32 = 0 To Registry.Count - 1
                If Registry(i) = n Then
                    n = n + 1
                ElseIf n < Registry(i) Then
                    Return n
                End If
            Next
            If n = Registry.Count Then
                Return Registry.Count
            End If
            Return ret
        End Function
    End Class

End Namespace

